polls/urls.py
""" map views to a URL - URLconf """

from django.urls import path

from . import views

app_name = 'polls'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('<int:pk>/', views.DetailView.as_view(), name='detail'),
    path('<int:pk>/results/', views.ResultsView.as_view(), name='results'),
    path('<int:question_id>/vote/', views.vote, name='vote'),
]

src/onboard/urls.py
""" map views to a URL - URLconf """

from django.conf.urls import url
from django.shortcuts import render
from django.urls import path

from .views import MessageCreateView, BroadcastMessageCreateView
from . import views

app_name = 'onboard'

urlpatterns = [
    path('', views.home, name='onboard-home'),
    path('messages/', MessageCreateView.as_view(), name='onboard-tanbot'),
    url(r'^api/(?P<username>.+)$', views.tanbot_api, name='tanbot-api'),
    path('slack/', views.slack_verification_challenge),
    path('broadcast/', BroadcastMessageCreateView.as_view(), name='onboard-broadcast'),
]

src/tanbot/urls.py
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.urls import path, include
from users import views as user_views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('register/', user_views.register, name='register'),
    path('login/', auth_views.LoginView.as_view(template_name='users/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='users/logout.html'), name='logout'),
    path('profile/', user_views.profile, name='profile'),
    path('polls/', include('polls.urls')),
    path('', include('onboard.urls')),
]

src/onboard/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
from django.urls import reverse


class Message(models.Model):
    slack_channel = models.TextField(default='Tangible AI')
    sent_from = models.ForeignKey(User, null=True, on_delete=models.CASCADE)
    sent_to = models.ForeignKey(User, null=True, on_delete=models.CASCADE, related_name='sent_to')
    date_scheduled = models.DateTimeField(default=timezone.now)
    date_sent = models.DateTimeField(default=timezone.now)
    message_title = models.TextField(blank=True, null=True)
    message_text = models.TextField(default='')

    def __str__(self):
        return self.message_title or self.message_text

    def get_absolute_url(self):
        return reverse('onboard:onboard-tanbot')


class SheduledMessage(models.Model):
    scheduled_time = models.DateTimeField()
    message_title = models.TextField(default='')
    message_text = models.TextField(default='')
    sent_to = models.ForeignKey(User, null=True, on_delete=models.CASCADE)

    def __str__(self):
        return self.message_title

src/onboard/views.py
import json
import markdown
import os
import pathlib
import slack
import re

from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.http import JsonResponse
from django.shortcuts import render
from django.views.generic import CreateView
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework import status
from qary.skills import eliza  # ,qa
from slack_sdk import WebClient

from .models import Message, SheduledMessage
# from users.models import Profile

SLACK_BOT = '<@U01JBL45U3Z>'


@login_required
def home(request):
    user = request.user
    chat_messages = Message.objects.filter(sent_from=user).order_by('-date_sent')[:3]
    template = 'onboard/home.html'
    return render(request, template, {'chat_messages': chat_messages, 'user': user})


class MessageCreateView(LoginRequiredMixin, CreateView):
    model = Message
    fields = ['message_text']
    context_object_name = 'chat_messages'
    ordering = ["-date_sent"]

    def form_valid(self, form):
        form.instance.sent_from = self.request.user
        return super().form_valid(form)

    def render_to_response(self, context, *args, **kwargs):
        user = self.request.user
        context['user'] = user
        context['sent_from'] = Message.objects.filter(sent_to=user).all()
        context['sent_to'] = Message.objects.filter(sent_from=user).all()

        if context['sent_from'] | context['sent_to']:
            context['all_messages_of_user'] = (context['sent_from'] | context['sent_to']).order_by('-date_sent')
            context['last_messages_of_user'] = (context['sent_from'] | context['sent_to']).last().message_text
        else:
            context['all_messages_of_user'] = 'No messages to display'
            context['last_messages_of_user'] = 'No messages to display'

        context['current_tanbot_message_id'] = User.objects.get(username=user).profile.latest_tanbot_message_id
        current_tanbot_message_id = context['current_tanbot_message_id']

        try:
            context['last_sheduled_message'] = SheduledMessage.objects.get(id=current_tanbot_message_id).message_text
        except SheduledMessage.DoesNotExist:
            context['last_sheduled_message'] = 'There are currently no more onboard messages to display'

        md = markdown.Markdown()
        md_to_html_last_sheduled_message = md.convert(context['last_sheduled_message'])

        tanbot_message = Message(sent_to=User.objects.get(username=user),
                                 sent_from=User.objects.get(username='Tanbot'),
                                 message_text=md_to_html_last_sheduled_message)

        if context['last_messages_of_user'] == 'onboard':
            context['test'] = 'This will be a sheduled_message'
            tanbot_message.save()
            profile = user.profile
            profile.latest_tanbot_message_id += 1
            profile.save()

        bot_name = 'eliza'
        bot_name_regex = f'^{bot_name}\\b'
        match = re.match(bot_name_regex, context['^last_messages_of_user'].strip().lower())
        if match:
            text = context['last_messages_of_user'][match.span(0)[1] + 1:].strip()
            bot_text = eliza.Skill().reply(text)[0][1]

            tanbot_message = Message(sent_to=User.objects.get(username=user),
                                     sent_from=User.objects.get(username='Tanbot'),
                                     message_text=bot_text)

            tanbot_message.save()

        # if context['last_messages_of_user'].startswith('qary '):
        #     text = context['last_messages_of_user'].split("qary ")[1]
        #     bot_text = qa.Skill().reply(text)[0][1]

        #     tanbot_message = Message(sent_to=User.objects.get(username=user),
        #                              sent_from=User.objects.get(username='Tanbot'),
        #                              message_text=bot_text)

        #     tanbot_message.save()

        return super().render_to_response(context, *args, **kwargs)


def tanbot_api(request, username):
    data = {}
    user = User.objects.get(username=username)
    # data['current_user'] = user.username
    if Message.objects.filter(sent_to=user):
        data['sent_from'] = str(Message.objects.filter(sent_to=user).last().sent_from)
        data['sent_to'] = str(Message.objects.filter(sent_to=user).last().sent_to)
        # data['date_sent'] = Message.objects.filter(sent_to=user).last().date_sent
        current_tanbot_message_id = User.objects.get(username=user).profile.latest_tanbot_message_id - 1
        try:
            data['current_sheduled_message_md'] = SheduledMessage.objects.get(id=current_tanbot_message_id).message_text
            data['current_sheduled_message_html'] = Message.objects.filter(sent_to=user).last().message_text
        except SheduledMessage.DoesNotExist:
            data['there_are_currently_no_more_onboard_messages_to_display'] = (
                "There are currently no more onboard messages to display")
    else:
        data['user_has_not_started_the_onboard_process'] = "user has not started the onboard process"
    return JsonResponse(data)


# SLACK API Configurations
if os.environ.get('VERIFICATION_TOKEN'):
    VERIFICATION_TOKEN = os.environ.get('VERIFICATION_TOKEN')
    OAUTH_ACCESS_TOKEN = os.environ.get('OAUTH_ACCESS_TOKEN')
    CLIENT_ID = os.environ.get('CLIENT_ID')
    CLIENT_SECRET = os.environ.get('CLIENT_SECRET')

if pathlib.Path('/etc/config.json').is_file():
    with open('/etc/config.json') as config_file:
        config = json.load(config_file)
    VERIFICATION_TOKEN = config['VERIFICATION_TOKEN']
    OAUTH_ACCESS_TOKEN = config['OAUTH_ACCESS_TOKEN']
    CLIENT_ID = config['CLIENT_ID']
    CLIENT_SECRET = config['CLIENT_SECRET']


@api_view(['GET', 'POST'])
def slack_verification_challenge(request):
    with open('/tmp/django_log.txt', 'a') as f_out:
        f_out.write(f'this is the request {request}')

    client = WebClient(token=OAUTH_ACCESS_TOKEN)
    slack_message = request.data

    if slack_message.get('token') != VERIFICATION_TOKEN:
        return Response(status=status.HTTP_403_FORBIDDEN)

    # verification challenge
    if slack_message.get('type') == 'url_verification':
        return Response(data=slack_message,
                        status=status.HTTP_200_OK)

    if 'event' in slack_message:
        event_message = slack_message.get('event')

        # process user's message
        user = event_message.get('user')
        text = event_message.get('text')
        channel = event_message.get('channel')
        username = f'<@{user}>'

        if not User.objects.filter(username=username).exists():
            bot_text = f'Hello <@{user}> :wave:'
            client.chat_postMessage(channel=channel, text=bot_text)

            User.objects.create_user(username=f'<@{user}>', password='1pass2word')
            # bot_text = f' I made account for you at (staging.qary.ia)'
            # client.chat_postMessage(channel=channel, text=bot_text)

            bot_text = "type 'onboard' to begin your onboarding process"
            client.chat_postMessage(channel=channel, text=bot_text)
            return Response(status=status.HTTP_200_OK)

        app_user = User.objects.get(username=username)

        if username != SLACK_BOT:
            tanbot_message = Message(sent_to=User.objects.get(username=SLACK_BOT),
                                     sent_from=app_user, message_text=text)

            tanbot_message.save()

        else:
            tanbot_message = Message(sent_to=app_user,
                                     sent_from=User.objects.get(username=SLACK_BOT),
                                     message_text=text)

            tanbot_message.save()

        if text.lower() == 'hi':
            bot_text = f'Hello <@{user}> :wave:'
            client.chat_postMessage(channel=channel, text=bot_text)

            tanbot_message = Message(sent_to=app_user,
                                     sent_from=User.objects.get(username=SLACK_BOT),
                                     message_text=bot_text)

            tanbot_message.save()
            return Response(status=status.HTTP_200_OK)

        if text.lower() == 'onboard':

            current_tanbot_message_id = User.objects.get(username=username).profile.latest_tanbot_message_id

            try:
                last_sheduled_message = SheduledMessage.objects.get(id=current_tanbot_message_id).message_text
            except SheduledMessage.DoesNotExist:
                last_sheduled_message = 'There are currently no more onboard messages to display'

            bot_text = last_sheduled_message
            client.chat_postMessage(channel=channel, text=bot_text)

            tanbot_message = Message(sent_to=app_user,
                                     sent_from=User.objects.get(username=SLACK_BOT),
                                     message_text=bot_text)

            tanbot_message.save()

            profile = app_user.profile
            profile.latest_tanbot_message_id += 1
            profile.save()

            return Response(status=status.HTTP_200_OK)

        if text.startswith('broadcast '):
            text = text.split("broadcast ")[1]
            client.chat_postMessage(channel='#interns', text=text)

            tanbot_message = Message(sent_to=User.objects.get(username=SLACK_BOT),
                                     sent_from=User.objects.get(username=SLACK_BOT),
                                     message_title='broadcast', message_text=bot_text)

            tanbot_message.save()

            return Response(status=status.HTTP_200_OK)

        skill = app_user.profile.qary_skills

        if text.lower() == 'stop':
            app_user.profile.qary_skills = ''
            app_user.save()
            bot_text = f'You are no longer talking with {skill.title()}.'

src/onboard/templates/onboard/base.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">

    <link rel="stylesheet" type="text/css" href="{% static 'onboard/main.css' %}">

</head>

<body>
  <br>
    <header class="site-header">
      <nav class="navbar navbar-expand-md navbar-dark bg-steel fixed-top">
        <div class="container">
          <a class="navbar-brand mr-4" href="{%url 'onboard:onboard-home' %}">Onboard</a>
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle" aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarToggle">
            <div class="navbar-nav mr-auto">
              <a class="nav-item nav-link" href="{%url 'onboard:onboard-home' %}">Home</a>
              <a class="nav-item nav-link" href="/polls">Polls</a>
            </div>
            <!-- Navbar Right Side -->
            <div class="navbar-nav">
              {% if user.is_authenticated %}
                <a class="nav-item nav-link" href="{% url 'onboard:onboard-tanbot' %}">Tanbot</a>

                <a class="nav-item nav-link" href="{% url 'profile' %}">Profile</a>
                <a class="nav-item nav-link" href="{% url 'logout' %}">Logout</a>
              {% else %}
                <a class="nav-item nav-link" href="{% url 'login' %}">Login</a>
                <a class="nav-item nav-link" href="{% url 'register' %}">Register</a>
              {% endif %}
            </div>
          </div>
        </div>
      </nav>
    </header>

    <main role="main" class="container">
      <div class="row">
        <div class="col-lg">
          {% if messages %}
            {% for message in messages %}
              <div class="alert alert-{{message.tags }}">
                {{ message }}
              </div>
            {% endfor %}
          {% endif %}
          {% block content %}{% endblock %}
        </div>
<!--         <div class="col-md-4">
          <div class="content-section">
            <h3>Our Sidebar</h3>
            <p class='text-muted'>You can put any information here you'd like.
              <ul class="list-group">
                <li class="list-group-item list-group-item-light">Latest Posts</li>
                <li class="list-group-item list-group-item-light">Announcements</li>
                <li class="list-group-item list-group-item-light">Calendars</li>
                <li class="list-group-item list-group-item-light">etc</li>
              </ul>
            </p>
          </div> -->
        </div>
      </div>
    </main>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</body>
</html>

src/onboard/templates/onboard/broadcast_message_form.html
{% extends "onboard/base.html" %}
{% load crispy_forms_tags %}
{% block content %}
    <h1>Internbot Broadcast #interns</h1>
    <br />
<p>This message will be broadcast to the interns channel </p>
    <div class="col-lg">
    <div class="content-section">
        <form method="POST">
            {% csrf_token %}
            <fieldset class="form-group">
<!--             <label for="id_message_text" class=" requiredField">
                Message text<span class="asteriskField">*</span> </label> -->
                {{ form|crispy }}
            </fieldset>
            <div class="form-group">
                <button class="btn btn-outline-info btn-sm type="submit">Submit</button>
            </div>
        </form>

    <div>
        <h4 style="color: darkred">last internbot broadcast:</h4>{{ latest_internbot_message }}
<!--         {% if sent_to %}
            {% for message in all_messages_of_user %}
                <div class="article-metadata">
                  <small class="date"><u>{{ message.date_sent }}</u></small>

                <p class="mr-2"> <small class="date">{{ message.sent_from }}:
                </small>&nbsp &nbsp{{ message.message_text | safe }}</p>
            {% endfor %}
        {% endif %} -->
    </div>
{% endblock content %}

src/onboard/templates/onboard/chat.html
{% extends "onboard/base.html" %}
<title>Chat</title>
{% block content %}
    <h1>Onboard Chat</h1>
    <br />
    <br />
    <article class="media content-section">
      <div class="media-body">
        {% for message in user.message_set.all %}
            <div class="article-metadata">
              <small class="date">{{ message.date_sent }}</small>
            </div>
            <p class="mr-2"> <small class="date">{{ message.sent_from }}:
            </small>&nbsp &nbsp{{ message.message_text }}</p>
        {% endfor %}
      </div>
    </article>

{% endblock content %}

src/onboard/templates/onboard/home.html
{% extends "onboard/base.html" %}
<title>Tanbot</title>
{% block content %}
    <h1>Welcome to Tangible AI Onboard</h1>
    <br />
    <br />
    <p>Head over to <a href="{% url 'onboard:onboard-tanbot' %}">Tanbot</a> and type <em>'onboard'</em> to start your onboard process.</p>
    <p>
        If you find a bug, have a suggestion for improving a feature, or have ideas for new features
        please open a <a href="https://gitlab.com/tangibleai/tanbot/-/issues" target="_blank">New issue</a> on GitLab.
    </p>
{% endblock content %}

src/onboard/templates/onboard/index.html
  <!DOCTYPE html>

 {% load static %}



{% if latest_question_list %}
    <ul>
    {% for profile in profiles %}
<!--         <li><a href="'/onboard:profile/'{{profile.id}}">{{ profile.slack_username }}</a></li> -->
    {% endfor %}
    </ul>
{% else %}
    <p>No profiles are available. </p>
{% endif %}

src/onboard/templates/onboard/message_detail.html
{% extends "onboard/base.html" %}
<title>Chat</title>
{% block content %}
    <h1>Onboard Chat</h1>
    <article class="media content-section">
      <div class="media-body">
        <div class="article-metadata">
          <small class="mr-2"> {{ object.sent_from }}</small>
          <small class="date">{{ object.date_sent }}</small>
        </div>
        <p class="article-content">{{ object.message_text }}</p>
      </div>
    </article>
{% endblock content %}

src/onboard/templates/onboard/message_form.html
{% extends "onboard/base.html" %}
{% load crispy_forms_tags %}
{% block content %}
    <h1>Tanbot</h1>
    <br />
<p>You can type <em>'onboard'</em> at any time to move on to the next section. *This is currently the only command that I understand.</p>
    <div class="col-lg">
    <div class="content-section">
        <form method="POST">
            {% csrf_token %}
            <fieldset class="form-group">
<!--             <label for="id_message_text" class=" requiredField">
                Message text<span class="asteriskField">*</span> </label> -->
                {{ form|crispy }}
            </fieldset>
            <div class="form-group">
                <button class="btn btn-outline-info btn-sm type="submit">Submit</button>
            </div>
        </form>

    <div>
        {% if user and sent_to %}
            {% for message in all_messages_of_user %}
                <div class="article-metadata">
                  <small class="date"><u>{{ message.date_sent }}</u></small>

                <p class="mr-2"> <small class="date">{{ message.sent_from }}:
                </small>&nbsp &nbsp{{ message.message_text | safe }}</p>
            {% endfor %}
        {% endif %}
    </div>
{% endblock content %}

src/onboard/templates/onboard/profile.html
<!DOCTYPE html>

Hello World!

src/onboard/templates/onboard/user_messages.html
{% extends "onboard/base.html" %}
<title>Chat</title>
{% block content %}
    <h1>Onboard Chat</h1>
    <br />
    <br />
    <article class="media content-section">
      <div class="media-body">
        {% for message in chat_messages %}
            <div class="article-metadata">
              <small class="date">{{ message.date_sent }}</small>
            </div>
            <p class="mr-2"> <small class="date">{{ message.sent_from }}:
            </small>&nbsp &nbsp{{ message.message_text }}</p>
        {% endfor %}
      </div>
    </article>

{% endblock content %}